import { getDqtdTableData, getQqzzTableData } from "../data/table/newConstruct/jhjd";
import { lcbsjTableData } from "../data/table/ztjsgl/lcbsjData";
import { tablePackage } from "../dataPackage/inFrontOut";



export async function getQqzz(req, res) {
    let line = req.query.line || "全部";
    let type = req.query.type || "专项规划";

    let excelData = getQqzzTableData();

    let result:any = {};


    /**
     * "线":{
     *      yearCount:0, 
     *      data:{
     *          "单体规划建设方案":{
     *              plan:0,
     *              complete:0
     *          }
     *         
     *      } 
     * }
     */
    let dataMap = {"undefined":{
        total:0,
        data:{
            "单体规划建设方案":{plan:0, complete:0},
            "单体建设用地规划许可证":{plan:0, complete:0},
            "单体建设工程规划许可证":{plan:0, complete:0},
            "单体施工许可证":{plan:0, complete:0}
        }
    }}; 

    let conf = {
        "单体规划建设方案":[4,5], 
        "单体建设用地规划许可证":[6,7],
        "单体建设工程规划许可证":[8,9],
        "单体施工许可证":[10,11]
    };

    excelData["前期管理数据"].bodyList.forEach(subList => {
        let dataLine = subList[0];
        let dataYear = subList[1];
        if (!dataMap[dataLine]) dataMap[dataLine] = {data:{} };
        dataMap[dataLine]["total"] = subList[2];

        
        for (let name in conf) {
            let plan = subList[conf[name][0]];
            let complete = subList[conf[name][1]];
            if (!dataMap[dataLine]["data"][name]) dataMap[dataLine]["data"][name] = {plan:0, complete:0};
            dataMap[dataLine]["data"][name]["plan"] += plan;
            dataMap[dataLine]["data"][name]["complete"] += complete;
        }

    });

    result["completionStatus"] = {
        "total":0,
        "complete":0,//完成 
        "incomplete":0,//未完成
    };

    if (line == "全部") {
        let scheduleMap = {};
        let planCount = 0;
        let completeCount = 0;
        for (let key in dataMap) {
            let {data, total} = dataMap[key];
            result["completionStatus"].total += total || 0;
            for (let name in data) {
                let {plan, complete} = data[name];
                if (!scheduleMap[name]) scheduleMap[name] = {plan:0, complete:0}
                scheduleMap[name].plan += plan;
                scheduleMap[name].complete += complete;
                planCount += plan;
                completeCount += complete;
            }
        }
        result["completionStatus"].complete = completeCount;
        result["completionStatus"].incomplete = planCount-completeCount;
        let scheduleList = [];
        for (let key in scheduleMap) {
            let subComplete = scheduleMap[key].complete;
            let subPlan = scheduleMap[key].plan;

            scheduleList.push({
                name:key,
                total:subPlan,
                complete:subComplete,
                incomplete:subPlan-subComplete
            });
        }
        result["scheduleList"] = scheduleList;

    } else {
        let onceLineData = dataMap[line] || dataMap["undefined"];
        result["completionStatus"].total = onceLineData.total;
        let complete = 0;
        let scheduleList = [];
        for (let key in onceLineData.data) {
            let subComplete = onceLineData.data[key].complete;
            let subPlan = onceLineData.data[key].plan;
            complete += subComplete;
            scheduleList.push({
                name:key,
                total:subPlan,
                complete:subComplete,
                incomplete:subPlan-subComplete
            });
        }
        result["completionStatus"].complete = complete;
        result["completionStatus"].incomplete =  onceLineData.total - complete;
        result["scheduleList"] = scheduleList;
    }
    
    

    res.send(result);
}

export async function getDqtd(req, res) {
    let line = req.query.line || "总数";
    let type = req.query.type || "专项规划";
    let year = req.query.type || 2023;
    let excelData = getDqtdTableData();
    let dataMap = {};
    excelData["概览数据"].bodyList.forEach(info => {
        dataMap[info[0]] = {
            "total":info[1],
            "complete":info[2],
            "incomplete":info[3],
        }
    });
    let result:any = {};
    result["completionStatus"] = dataMap[line];
   
    result["detailedList"] = [
        {
            "name":"居民",
            "total":100,
            "complete":10,
            "incomplete":90,
        },
        {
            "name":"单位",
            "total":100,
            "complete":10,
            "incomplete":90,
        },
        {
            "name":"绿地",
            "total":100,
            "complete":10,
            "incomplete":90,
        },
    ]

    
    // result["scheduleList"] = [
    //     {
    //         "name":"单体规划设计方案",
    //         "total":100,
    //         "complete":10,
    //         "incomplete":90,
    //     },
    //     {
    //         "name":"单体建设用地规划许可证",
    //         "total":100,
    //         "complete":10,
    //         "incomplete":90,
    //     }
    // ]
    res.send(result);
}

export async function getXxjd(req, res) {
    let line = req.query.line || "全部";
    let result:any = {};
    result["scheduleList"] = [
        {
            "name":"车站",
            "total":0,
            "complete":0,
            "inProgress":0,
            "notStarted":0
        },
        {
            "name":"车辆基地",
            "total":0,
            "complete":0,
            "inProgress":0,
            "notStarted":0
        },
        {
            "name":"高架区间",
            "total":0,
            "complete":0,
            "inProgress":0,
            "notStarted":0
        }
    ];

    res.send(result);
}

export async function getLcbjd(req, res) {

    let result:any = {};
    result["detailedList"] = [
        {
            title:"23号线首座车站开工",
            time:"2022-09-19", 
            desc:"23号线江川东路站于2022-9-19首幅低下连续墙开工。", 
            img:"http://192.168.0.71:40001/2005_01.jpg"
        },
        {
            title:"23号线首座车站开工",
            time:"2022-09-19", 
            desc:"23号线江川东路站于2022-9-19首幅低下连续墙开工。", 
            img:"http://192.168.0.71:40001/2005_01.jpg"
        },
       
    ];

    res.send(result);
}